<?php
/**
 * Pocket Project
 * 
 * @copyright 2006 Power-Station co., Ltd, ALL Rights Reserved,
 */

/**
 *  トピック情報登録用のActionクラス
 *
 *  @author     Shogo Minami
 *  @access     public
 *  @package    PocketBBS.pc.do
 */
class topicInsertAction extends Pocket_Bbs_Action
{
    /**
     *  アクション実行
     *
     *  @access public
     *  @param  object  $controller         コントローラ
     *  @param  object  $request            リクエスト情報
     *  @return string  success,error
     */
    function execute(&$controller, &$request)
    {
        // リクエスト情報の取得
        $author_name     = $request['author_name'];
        $author_email    = $request['author_email'];
        $subject         = $request['subject'];
        $body            = $request['body'];
        $category_id     = $request['category_id'];
        $allow_comment   = $request['allow_comment'];
        $author_password = $request['author_password'];

        // トピック作成機能のチェック
        if (!IS_TOPIC_ENTRY && !pocket_isAuth())
            pocket_redirect('default.view');

        // トピックの登録
        $topic_id = db_insert_topic($author_name, $author_email, $subject, $body, $category_id, $allow_comment, md5($author_password));

        // トピック投稿メールの送信
        pbb_sendTopicMail(db_get_user4first_user_id(), $topic_id, $author_name, $subject);

        // リダイレクト
        pocket_redirect('topicComment.view', array('topic_id' => $topic_id));
    }

    /**
     *  リクエスト検証
     *
     *  @access public
     *  @param  object  $validator          バリデータ
     *  @param  object  $request            リクエスト情報
     */
    function validate(&$validator, &$request)
    {
        // リクエスト情報の取得
        $author_name     = $request['author_name'];
        $author_email    = $request['author_email'];
        $subject         = $request['subject'];
        $body            = $request['body'];
        $category_id     = $request['category_id'];
        $author_password = $request['author_password'];

        // エラー表示用のAction名称の設定
        $this->viewAction = 'topicEntry';

        // 検証
        $validator->validate('author_name'    , '名前'    , $author_name    , 'string'     , true);
        $validator->validate('author_email'   , 'E-Mail'  , $author_email   , 'email');
        $validator->validate('subject'        , 'タイトル', $subject        , 'string'     , true);
        $validator->validate('category_id'    , 'カテゴリ', $category_id    , 'number'     , true);
        $validator->validate('body'           , '本文'    , $body           , 'string'     , true);
        $validator->validate('author_password', '暗証番号', $author_password, 'alnum'      , true);
        $validator->validate('author_password', '暗証番号', $author_password, '/^[\w]{4}$/', true);
    }
}

?>
